// Bump (TeBe/Madteam) 02.09.1999 - 29.11.2012

unit bump;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;

  texture, tlight: array [0..127, 0..127] of byte;

  lpos: array [0..255] of byte;  

  aborted: Boolean;
       
const
 light   = 128;
 swidth  = 128;
 sheight = 128;


implementation

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
var x,y, dist, dx,dy, add_x,add_y: integer;
    bmp: TBitmap;
    c, u,v, xdif,ydif: byte;
begin

{ texture }

 bmp:=TBitmap.Create;
 bmp.LoadFromFile('t128_1.bmp');
 bmp.PixelFormat:=pf24bit;

 for y:=0 to sheight do
  for x:=0 to swidth do texture[x,y] := GetRValue(bmp.Canvas.Pixels[x,y]);

 bmp.width:=swidth;
 bmp.Height:=sheight;


{ CALCULATE LIGHT }

 for y:=0 to light-1 do
  for x:=0 to light-1 do begin

   dist:=(light div 2) - round(sqrt( sqr(x-light div 2) + sqr(y-light div 2))) - 1;

   if dist<0 then dist:=0;

   tlight[x,y]:=dist;
  end;


{ CALCULATE X:Y NORMALIZATION TABLE }

 for x := 0 to light-1 do lpos[128-light div 2+x]:=x;


{ BUMP - MAIN LOOP }

dx:=light shr 1;
dy:=light shr 1;

add_x:=5; add_y:=3;

aborted:=false;

repeat

 sleep(50);

 Application.ProcessMessages; // <-- konieczna linia
 if Aborted then Break;

 for y:=1 to sheight-2 do
  for x:=1 to swidth-2 do begin

   xdif:=texture[x+1,y] - texture[x-1,y];
   ydif:=texture[x,y+1] - texture[x,y-1];

   u:=lpos[xdif+x+dx];
   v:=lpos[ydif+y+dy];

   c := tlight[u, v];

   bmp.Canvas.Pixels[x,y] := rgb(c,c,c);

  end;

  dx:=dx+add_x; if (dx>light) or (dx<0) then add_x:=-add_x;
  dy:=dy+add_y; if (dy>light) or (dy<0) then add_y:=-add_y;

  image1.Picture.Graphic:=bmp;
  
until false;

 bmp.free;
end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 aborted := true;
end;

end.

